using System;

using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace StilltoMovie
{
	/// <summary>
	/// Summary description for ImageList.
	/// </summary>
    /// 
	public class ImageList : System.Windows.Forms.Form
	{
			Random rnd = new Random();
            Bitmap motionimg;
            Bitmap[] FinalFrame = new Bitmap[2000];
            int cnt = 0;

		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.TrackBar trackBar1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
        private Button button1;
		Bitmap[] Bmp;
        int Bmpcnt;

        int imgwidth;
        private ProgressBar progressBar1;
        private Label label5;
        private TextBox textBox1;
        private TextBox textBox2;
        private Label label6;
        private Label label7;
        private TextBox textBox3;
        int imghieght;

		public ImageList(Bitmap[] bmp,int bmpcnt)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			
            trackBar1.Minimum = 1;
			Bmp=bmp;
            Bmpcnt = bmpcnt; 

			trackBar1.Maximum = bmpcnt;
			pictureBox1.Image = Bmp[1];

            imgwidth = bmp[1].Width;
            imghieght = bmp[1].Height;  

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		/// 	
		
		public int val(int cnt)
		{
		return rnd.Next(cnt);
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.label4 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.progressBar1 = new System.Windows.Forms.ProgressBar();
            this.trackBar1 = new System.Windows.Forms.TrackBar();
            this.pictureBox1 = new System.Windows.Forms.PictureBox();
            this.button1 = new System.Windows.Forms.Button();
            this.label5 = new System.Windows.Forms.Label();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.textBox2 = new System.Windows.Forms.TextBox();
            this.label6 = new System.Windows.Forms.Label();
            this.label7 = new System.Windows.Forms.Label();
            this.textBox3 = new System.Windows.Forms.TextBox();
            this.groupBox1.SuspendLayout();
            this.groupBox2.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.trackBar1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
            this.SuspendLayout();
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.label4);
            this.groupBox1.Controls.Add(this.label3);
            this.groupBox1.Controls.Add(this.label2);
            this.groupBox1.Controls.Add(this.label1);
            this.groupBox1.Controls.Add(this.groupBox2);
            this.groupBox1.Location = new System.Drawing.Point(12, 12);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(770, 547);
            this.groupBox1.TabIndex = 0;
            this.groupBox1.TabStop = false;
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(600, 16);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(80, 16);
            this.label4.TabIndex = 16;
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(480, 16);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(100, 16);
            this.label3.TabIndex = 15;
            this.label3.Text = "Size";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(240, 16);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(100, 16);
            this.label2.TabIndex = 14;
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(96, 16);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(88, 16);
            this.label1.TabIndex = 13;
            this.label1.Text = "Ordering Index :";
            this.label1.Visible = false;
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.progressBar1);
            this.groupBox2.Controls.Add(this.trackBar1);
            this.groupBox2.Controls.Add(this.pictureBox1);
            this.groupBox2.Location = new System.Drawing.Point(8, 32);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(756, 510);
            this.groupBox2.TabIndex = 12;
            this.groupBox2.TabStop = false;
            // 
            // progressBar1
            // 
            this.progressBar1.Location = new System.Drawing.Point(17, 463);
            this.progressBar1.Name = "progressBar1";
            this.progressBar1.Size = new System.Drawing.Size(717, 23);
            this.progressBar1.TabIndex = 2;
            this.progressBar1.Visible = false;
            // 
            // trackBar1
            // 
            this.trackBar1.LargeChange = 1;
            this.trackBar1.Location = new System.Drawing.Point(17, 463);
            this.trackBar1.Name = "trackBar1";
            this.trackBar1.Size = new System.Drawing.Size(717, 42);
            this.trackBar1.TabIndex = 1;
            this.trackBar1.Scroll += new System.EventHandler(this.trackBar1_Scroll);
            // 
            // pictureBox1
            // 
            this.pictureBox1.Location = new System.Drawing.Point(8, 16);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new System.Drawing.Size(726, 441);
            this.pictureBox1.TabIndex = 0;
            this.pictureBox1.TabStop = false;
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(707, 581);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(75, 23);
            this.button1.TabIndex = 1;
            this.button1.Text = "ConvertAVI";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // label5
            // 
            this.label5.AutoSize = true;
            this.label5.Location = new System.Drawing.Point(378, 581);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(59, 13);
            this.label5.TabIndex = 2;
            this.label5.Text = "FrameTime";
            // 
            // textBox1
            // 
            this.textBox1.Location = new System.Drawing.Point(443, 578);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new System.Drawing.Size(100, 20);
            this.textBox1.TabIndex = 3;
            this.textBox1.Text = "1";
            // 
            // textBox2
            // 
            this.textBox2.Location = new System.Drawing.Point(294, 578);
            this.textBox2.Name = "textBox2";
            this.textBox2.Size = new System.Drawing.Size(58, 20);
            this.textBox2.TabIndex = 4;
            this.textBox2.Text = "200";
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Location = new System.Drawing.Point(225, 581);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(63, 13);
            this.label6.TabIndex = 5;
            this.label6.Text = "Motion Limit";
            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Location = new System.Drawing.Point(15, 581);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(98, 13);
            this.label7.TabIndex = 7;
            this.label7.Text = "Motion Smoothning";
            // 
            // textBox3
            // 
            this.textBox3.Location = new System.Drawing.Point(119, 578);
            this.textBox3.Name = "textBox3";
            this.textBox3.Size = new System.Drawing.Size(58, 20);
            this.textBox3.TabIndex = 6;
            this.textBox3.Text = "50";
            // 
            // ImageList
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(789, 610);
            this.Controls.Add(this.label7);
            this.Controls.Add(this.textBox3);
            this.Controls.Add(this.label6);
            this.Controls.Add(this.textBox2);
            this.Controls.Add(this.textBox1);
            this.Controls.Add(this.label5);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.groupBox1);
            this.Name = "ImageList";
            this.Text = "ImageList";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            this.groupBox1.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.trackBar1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		

		private void trackBar1_Scroll(object sender, System.EventArgs e)
		{
			pictureBox1.Image =  Bmp[trackBar1.Value];  

			label2.Text = (trackBar1.Value).ToString() ;
			label4.Text = (Bmp[trackBar1.Value].Width).ToString() + " X " +  (Bmp[trackBar1.Value].Height).ToString();
	}

		
        private void button1_Click(object sender, EventArgs e)
        {
           
            ImageLib.Imaging.Filters.MoveTowards motion = new ImageLib.Imaging.Filters.MoveTowards();
                
             for (int i = 1; i < Bmpcnt; i++)
             {

                 cnt++;
                 motionimg = Bmp[i];
                 FinalFrame[cnt] = motionimg;


                 progressBar1.Minimum = 0;
                 progressBar1.Maximum = Convert.ToInt32(textBox2.Text)+1;
                 progressBar1.Value = 0;
                 progressBar1.Visible = true;

                 for (int j = 1; j <= Convert.ToInt32(textBox2.Text); j++)
                 {
                     motionimg = motion.Applynew(motionimg,Bmp[i + 1]);
                     if (j % Convert.ToInt16(textBox3.Text)    == 0)
                     {
                         cnt++;
                         FinalFrame[cnt] = motionimg;
                     }
                     progressBar1.Value = progressBar1.Value + 1;

                 }
   
            }



            ///////////////////////////////////////////////////////



            SaveFileDialog sv = new SaveFileDialog(); 
            AVIAPP.AVIWriter aviw = new AVIAPP.AVIWriter();

            try
            {
                if (sv.ShowDialog() == DialogResult.OK)
                {
                    aviw.Open(sv.FileName + ".avi", imgwidth, imghieght);

                    int time = Convert.ToInt32(textBox1.Text);


                    progressBar1.Minimum = 0;
                    progressBar1.Maximum = (cnt * time) + 1;
                    progressBar1.Value = 0;
                    progressBar1.Visible = true;


                    for (int i = 1; i <= cnt; i++)
                    {
                        for (int j = 1; j <= time; j++)
                        {
                            aviw.AddFrame(FinalFrame[i]);
                            progressBar1.Value = progressBar1.Value + 1;
                        }

                    }
                    aviw.Close();
                    progressBar1.Visible = false;
                    aviw.Dispose();
                    MessageBox.Show("Process Completed Successfully");
                }
            }
            catch (Exception E)
            {
                MessageBox.Show(E.ToString());

            }
                                
            
            
        }
    }
}
